// Lab 30: Fl_Progress bar and Timer events Part I
// CMainWindow.cpp

#include "CMainWindow.h"

const double CMainWindow::TICK_TIMEOUT = 0.05; // seconds

CMainWindow::CMainWindow()
    :
m_progress_count( 0 )
{
}

void CMainWindow::show()
{
    // Window callbacks:
    win_app->callback( (Fl_Callback*)CMainWindow::callback_window_closing, (void*)(this) );
    btn_animate->callback( (Fl_Callback*)CMainWindow::callback_btn_animate, (void*)(this) );

    // Make the window visible:
    win_app->show();
}

// callback functions
void CMainWindow::callback_window_closing(Fl_Widget* widg, void* userdata_) {
    std::cout << "X button clicked -- exiting the program\n";
    while( Fl::first_window() ) {
        Fl::first_window()->hide();
    }
}

void CMainWindow::click_btn_animate()
{
    Fl::add_timeout( TICK_TIMEOUT, CMainWindow::callback_animate, this );
}

void CMainWindow::callback_btn_animate(Fl_Widget* widg, void* userdata_)
{
    CMainWindow* window = static_cast< CMainWindow* >( userdata_ );
    window->set_progress_count( DEFAULT_PROGRESS_COUNT );
    window->click_btn_animate();
}

void CMainWindow::callback_animate( void* userdata_ )
{
    CMainWindow* window = static_cast< CMainWindow* >( userdata_ );
    if ( window->animate() ) {
        Fl::repeat_timeout( TICK_TIMEOUT, CMainWindow::callback_animate, userdata_ );
    }
}

bool CMainWindow::animate()
{
    if ( !m_progress_count ) {
        return false;
    }
    --m_progress_count;
    std::cout << "animate " << m_progress_count << "\n";
    return true;
}

void CMainWindow::set_progress_count( int count )
{
    m_progress_count = count;
}
